#ifndef __eor_included
#define __eor_included

#include "config.h"

#include "iff.h"

#include "cpppro.h"

#define TEXTURETAGSZ sizeof(struct TextureTag)
struct TextureTag
{
  char name[9];
  int xres, yres;
  iff_char * bitmap;
}; 

#ifdef _MSC_VER
#pragma pack(push, 1)
#endif

#define VERTEXTAGSZ sizeof(struct VertexTag)
struct VertexTag
{
  long x, y, z;
} PACKED;

#define TRISMAPTAGSZ sizeof(struct TrisMapTag)
struct TrisMapTag
{
  iff_half id;
  iff_half textureid;
  iff_half ax, ay;
  iff_half bx, by;
  iff_half cx, cy;
} PACKED;

#define QUADMAPTAGSZ sizeof(struct QuadMapTag)
struct QuadMapTag
{
  iff_half id;
  iff_half textureid;
  iff_half ax, ay;
  iff_half bx, by;
  iff_half cx, cy;
  iff_half dx, dy;
} PACKED;

#define LINEFACETAGSZ sizeof(struct LineFaceTag)
struct LineFaceTag
{
  iff_half something, a, b;
} PACKED;

#define TRISFACETAGSZ sizeof(struct TrisFaceTag)
struct TrisFaceTag
{
  iff_half something, a, b, c;
} PACKED;

#define QUADFACETAGSZ sizeof(struct QuadFaceTag)
struct QuadFaceTag
{
  iff_half something, a, b, c, d;
} PACKED;

#ifdef _MSC_VER
#pragma pack(pop)
#endif

#define REALTAGSZ sizeof(struct RealTag)
struct RealTag
{
  char name[9];
  int LineFaceCount;
  int TrisMapCount;
  int TrisFaceCount;
  int QuadMapCount;
  int QuadFaceCount;
  int VertexCount;
  int TextureCount;
  struct LineFaceTag * LineFaceList;
  struct TrisMapTag  * TrisMapList;
  struct TrisFaceTag * TrisFaceList;
  struct QuadMapTag  * QuadMapList;
  struct QuadFaceTag * QuadFaceList;
  struct VertexTag   * VertexList;
  struct TextureTag  * TextureList;
};

struct RealTag * eor_init(struct IFFStreamTag *);

#include "cppepi.h"

#endif /* __eor_included */
