#ifndef __mtn_included
#define __mtn_included

#include "config.h"

#include "iff.h"
#include "skl.h"

#include "cpppro.h"

#ifdef _MSC_VER
#pragma pack(push, 1)
#endif

#define MOTNMOTNTAGSZ sizeof(struct MotnMotnTag)
struct MotnMotnTag
{
  char name[20];
  iff_half unknown_h0;
  iff_word unknown_w0; /* sometimes lohalf == sizeof PRLE               */
  iff_half unknown_h1; /* usualy 0 in case of PRLE motion               */
  iff_half unknown_h2; /* somehow connected to motion sounds            */
  iff_half unknown_h3; /* somehow connected to ending position          */
  iff_char unknown_ca0[40]; /* sounds?                                  */
  iff_word unknown_w1; /* 0?                                            */
  iff_char speed;      /* somehow connected to the speed of the motion  */
  iff_half LimbCount;  /* how many limbs affected no deltas             */
  iff_half unknown_h4; /* POSE 18 + LimbCount * 8                       */
  iff_half PoseCount;  /* number of discrete poses in motion            */
} PACKED;   

/*
 * Should be fixed and moved to motn.c someday
 */
#define MOTNTAGSZ sizeof(struct MotnTag)
struct MotnTag
{
  struct MotnTag * link;
  struct MotnMotnTag motn;
  struct MotnDeltaTag * DeltaList;
  iff_char * AngleList;
};

#define MOTNDELTATAGSZ sizeof(struct MotnDeltaTag)
struct MotnDeltaTag
{
  iff_sword w0; /* dx? */
  iff_sword w1; /* dy? */
  iff_sword w2; /* dz? */
  iff_half h0; /* ? */
  iff_half h1; /* ? */
  iff_half h2; /* ? */
} PACKED;   


/* 
 * Layout of POSE chunk
 * 0..PoseCount
 *   long dx, dy, dz - (?) Root deltas
 *   ushort ?[3]
 *   0..LimbCount
 *     uchar xa, ya, za
 *     5 bytes - (?) controlling telescopic limb motion 
 */

/*
 * Layout of PRLE chunk
 * 0..PoseCount
 *   long dx, dy, dz - (?) Root deltas
 *   ushort ?[3]
 *   RLE packed data
 *   unpacked format
 *       Limb 0         uchar xa[PoseCount]
 *       Limb 1         uchar xa[PoseCount]
 *       Limb 2         uchar xa[PoseCount]
 *       ...
 *       Limb LimbCount uchar xa[PoseCount]
 *
 *       ----------------------------
 *       Limb 0         uchar ya[PoseCount]
 *       ...
 *       Limb LimbCount uchar ya[PoseCount]
 *
 *       ----------------------------
 *       Limb 0         uchar za[PoseCount]
 *       ...
 *       Limb LimbCount uchar za[PoseCount]
 */

extern struct MotnTag * mtn_init(struct IFFStreamTag *);

#ifdef _MSC_VER
#pragma pack(pop)
#endif

#include "cppepi.h"

#endif /* __mtn_included */
