#ifndef __skl_included
#define __skl_included

#include "config.h"

#include "iff.h"

#include "cpppro.h"

#ifdef _MSC_VER
#pragma pack(push, 1)
#endif

#define LIMBTAGSZ sizeof(struct LimbTag)

struct LimbTag
{
  char name[9];
  iff_half parent;

  iff_char xa;
  char pad0;

  iff_char ya;
  char pad1;

  iff_char za;
  char pad2;

  iff_char xaa;
  char pad3;

  iff_char yaa;
  char pad4;

  iff_char zaa;
  char pad5;

#if 0
  iff_half xa;
  iff_half sa;
  iff_half za;
  iff_half xaa;
  iff_half saa;
  iff_half zaa;
#endif
  iff_sword length;
  iff_sword dx;
  iff_sword dy;
  iff_sword dz;
} PACKED;

#define SKELTAGSZ sizeof(struct SkelTag)
struct SkelTag
{
  int LimbCount;
  struct LimbTag * LimbList;
};

extern struct SkelTag * skl_init(struct IFFStreamTag *);

#ifdef _MSC_VER
#pragma pack(pop)
#endif

#endif /* __skl_included */
