#ifndef __real_included
#define __real_included

#include "config.h"

#include "iff/iff.h"
#include "iff/eor.h"

#include "strm.h"

#include "cpppro.h"

#define MAP_TYPE_NONE 0
#define MAP_TYPE_TRIS 1
#define MAP_TYPE_QUAD 2

#define FACE_TYPE_NONE 0
#define FACE_TYPE_LINE 1
#define FACE_TYPE_TRIS 2
#define FACE_TYPE_QUAD 3

#define MAPTAGSZ sizeof(struct MapTag)
struct MapTag
{
  int MapType;
  union {
    struct TrisMapTag * TrisMap;
    struct QuadMapTag * QuadMap;
  } Map; 
};

#define FACETAGSZ sizeof(struct FaceTag)
struct FaceTag
{
  int FaceType;
  union {
    struct LineFaceTag LineFace;
    struct TrisFaceTag TrisFace;
    struct QuadFaceTag QuadFace;
  } Face;
};

#define RETRTAGSZ sizeof(struct RetrTag)
struct RetrTag
{
  struct RealTag * real;
  struct MapTag * MapList;
  int MapCount;
  float * VertexList;
  const uchar * palette;
  float xc;
  float yc;
  float zc;
  float rs;
};

DL_API(struct RetrTag *) real_init(const char *);
DL_API(void) real_done(struct RetrTag *);

#include "cppepi.h"

#endif /* __real_included */
