# use eorln or eorbn but do NOT mix them
import sys, iff, eorln, string

# TODO:
#   sort FaceList 
if not sys.argv[1:]:
	print "usage: %s object.eor > object.c" % (sys.argv[0])
	sys.exit(1)

name = sys.argv[1]
file = open(name, 'rb')
iff.process(file)

eor = eorln

xs = map(lambda e: e[0], eor.VertexList)
ys = map(lambda e: e[1], eor.VertexList)
zs = map(lambda e: e[2], eor.VertexList)
minx = min(xs)
maxx = max(xs)
miny = min(ys)
maxy = max(ys)
minz = min(zs)
maxz = max(zs)
xcenter = (minx + maxx) / 2.0
ycenter = (miny + maxy) / 2.0
zcenter = (minz + maxz) / 2.0
radscale = 1.0 / max(maxx - minx, maxy - miny, maxz - minz)

def normalize(e):
        x = (e[0] - xcenter) * radscale
        y = (e[1] - ycenter) * radscale
        z = (e[2] - zcenter) * radscale  
        return (x, y, z)

VertexList = map(normalize, eor.VertexList)

print '/* auto generated by %s from %s */' % (sys.argv[0], name)
print

print 'char * ObjectName = "%s";' % eor.ObjectName
print

print 'int VertexCount = %d;' % len(VertexList) 
print 'float VertexList[%d][3] = ' % (len(VertexList) + 1)
print '{'
for v in VertexList:
	print '  {%9ff, %9ff, %9ff},' % (v[0], v[1], v[2])
print '  {0.f, 0.f, 0.f}'
print '};'
print

print 'int FaceCount = %d;' % len(eor.TrisFaceList)
print 'int FaceList[%d][3] = ' % (len(eor.TrisFaceList) + 1)
print '{'
for f in eor.TrisFaceList:
	print '  {%4d, %4d, %4d},' % (f[0], f[1], f[2])
print '  {0, 0, 0}'
print '};'
print

i = 0
print 'int MapCount = %d;' % len(eor.TrisMapList)
print 'static struct eormap'
print '{'
print '  int mapid;'
print '  int texid;'
print '  int points[3][2];'
print '} Maps[%d] = ' % (len(eor.TrisMapList) + 1)
print '{'
for m in eor.TrisMapList:
	print '  { /* %d */' % i
        print '    %d, %d,' % (m[0], m[1])
        print '    {'
        print '      {%3d, %3d},' % (m[2][0], m[2][1])
        print '      {%3d, %3d},' % (m[3][0], m[3][1])
        print '      {%3d, %3d}' % (m[4][0], m[4][1])
        print '    }'
        print '  },'
        i = i + 1
print '  {0, 0, {{0, 0}, {0, 0}, {0, 0}}}'
print '};'
print

print 'struct eormap * MapList[%d] = ' % (len(eor.TrisFaceList) + 1)
print '{'
i, j = 0, 0
for m in eor.TrisMapList:
	n = m[0]
	while i < n:
        	print '  0,'
                i = i + 1
	else:
        	print '  &Maps[%d], ' % j
                i = i + 1
                j = j + 1
print '  0'
print '};'
print

#import sys
#sys.exit(1)

# first dump the texture data
for t in eor.TextureList:
       	size = t[1] * t[2]
        file.seek(t[3], 0)
        image = file.read(size)

        # more normalization need
        name = string.replace(t[0], '-', '_')

       	print 'static unsigned char %s[%d] = ' % (name, size)
        print '{'
	print ' ',
        
	start = 1
	i = 0
        pos = 0
	while size:
        	try:
                        import struct
               		c = struct.unpack('=b', image[pos])[0]
                	if start == 0:
                		print ',',
                	start = 0
                	print '0x%02x' % (c & 0xff),
		except EOFError:
        		break
                pos = pos + 1
                size = size - 1
                if not size: break
                i = i + 1
        	if i == 10:
        		i = 0
                	print ",\n ",
                	start = 1
		
        print
       	print '};'
        print
        # force garbage collection
        del(image)

print 'int TextureCount = %d;' % len(eor.TextureList)
print 'struct eortex '
print '{'
print '  int xres;'
print '  int yres;'
print '  unsigned char * image;'
print '} TextureList[%d] = ' % (len(eor.TextureList) + 1)
print '{'
for t in eor.TextureList:
        name = string.replace(t[0], '-', '_')
        print '  {%3d, %3d, (unsigned char *) &%s},' % (t[1], t[2], name)
print '  {0, 0, 0}'
print '};'
print

